<template>
  <div>
    <ul class="list-unstyled locus-property-list">
      <li>
        <h4>
          {{ locus.properties.ztf_object_id }}
        </h4>
      </li>
      <li>
        <strong>Num. Alerts:</strong> <span>{{ locus.properties.num_alerts }}</span>
      </li>
      <li>
        <strong>Num. Mag. Values:</strong> <span>{{ locus.properties.num_mag_values }}</span>
      </li>
      <li v-if="locus.tags.length">
        <strong>Associated Tags:</strong>
        <span>
          <a
            v-for="(tag, index) in locus.tags"
            :key="tag"
          >
            {{ tag }}
            <span v-if="index < locus.tags.size - 1">, </span>
          </a>
        </span>
      </li>
      <li>
        <strong>Alert Brokers: </strong>
        <a
          :href="'https://alerce.online/object/' + locus.properties.ztf_object_id"
          target="_blank"
        >
          ALeRCE
        </a>
      </li>
      <li>
        <strong>
          External Services
          <span
            v-b-tooltip.hover.v-primary
            title="Search for this object in these external services."
          >
            <font-awesome-icon icon="question-circle" /> </span>:
        </strong>
        <a
          :href="
            'https://irsa.ipac.caltech.edu/cgi-bin/Gator/nph-query?objstr=' +
              locus.ra +
              '+' +
              locus.dec +
              '+&catalog=ztf_objects_dr5&mission=irsa&radius=1'
          "
        >IPAC</a>,
        <a
          :href="
            'https://ned.ipac.caltech.edu/conesearch?search_type=Near+Position+Search&iau_style=liberal&objname=&coordinates=' +
              locus.ra +
              'd%2C' +
              locus.dec +
              'd&iau_name=&radius=0.017&in_csys=Equatorial&in_equinox=J2000' +
              '&in_csys_IAU=Equatorial&in_equinox_IAU=B1950&z_constraint=Unconstrained&z_value1=' +
              '&z_value2=&z_unit=z&ot_include=ANY&nmp_op=ANY&hconst=67.8&omegam=0.308' +
              '&omegav=0.692&wmap=4&corr_z=1&out_csys=Same+as+Input&out_equinox=Same+as+Input' +
              '&obj_sort=Distance+to+search+center&op=Go' +
              '&form_build_id=form-a28snc2SSIQl3faGUe4otq7_NcjnMwxxxPoVxw5LHzg&form_id=conesearch'
          "
        >NED</a>,
        <a
          :href="
            'http://simbad.u-strasbg.fr/simbad/sim-coo?Coord=' +
              locus.ra +
              '%2C' +
              locus.dec +
              '&CooFrame=FK5&CooEpoch=2000&CooEqui=2000&CooDefinedFrames=none&Radius=2' +
              '&Radius.unit=arcsec&submit=submit+query&CoordList='
          "
        >SIMBAD</a>,
        <a :href="'https://ztf.snad.space/search/' + locus.ra + '%20' + locus.dec + '/1'">SNAD</a>,
        <a
          :href="
            'https://www.wis-tns.org/search?&ra=' +
              locus.ra +
              '&decl=' +
              locus.dec +
              '&radius=1&coords_unit=arcsec'
          "
        >TNS</a>,
        <a
          :href="
            'https://vizier.u-strasbg.fr/viz-bin/VizieR-4?-ref=VIZ600f5483a73e&-to=-4c%3DGo%21b&-from=-1&-this=-4c%3DGo%21&%2F%2Fc=' +
              locus.ra +
              '+' +
              locus.dec +
              '-out.max=50&%2F%2FCDSportal=http%3A%2F%2Fcdsportal.u-strasbg.fr%2FStoreVizierData' +
              '.html&-out.form=HTML+Table&-out.add=_r&-out.add=_RAJ%2C_DEJ&%2F%2Foutaddvalue' +
              '=default&-sort=_r&-order=I&-oc.form=sexa&-nav=key%3Ac%3D' +
              locus.ra +
              '+' +
              locus.dec +
              '%26pos%3A' +
              locus.ra +
              '+' +
              locus.dec +
              '%28+++2+arcsec+J2000%29%26HTTPPRM%3A&-c=' +
              locus.ra +
              '+' +
              locus.dec +
              '&-c.eq=J2000&-c.r=++2&-c.u=arcsec&-c.geom=r&-source=&-meta.ucd=2&-meta=1' +
              '&-meta.foot=1&-usenav=1&-bmark=GET'
          "
        >VizieR</a>
      </li>
      <li class="mt-2">
        <b-button
          :disabled="loadingFinderChart"
          block
          size="sm"
          variant="success"
          @click="downloadFinderChart"
        >
          <font-awesome-icon
            v-if="loadingFinderChart"
            icon="spinner"
            pulse
            size="sm"
          />
          <font-awesome-icon
            v-else
            icon="download"
            size="sm"
          />
          Finder Chart
        </b-button>
      </li>
    </ul>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import axios from 'axios';

import { Locus } from '@/common/types';

export default Vue.extend({
  props: {
    locus: {
      required: true,
      type: Object,
    } as PropOptions<Locus>,
  },

  data() {
    return {
      loadingFinderChart: false,
    };
  },

  methods: {
    async downloadFinderChart() {
      this.loadingFinderChart = true;
      try {
        const url = `${(<any> this).ANTARES_API_URL}/loci/${this.locus.id}/finder-charts`;
        const response = await axios.post(url, null, {
          headers: {
            Accept: 'application/pdf',
          },
        });
        const downloadUrl = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = downloadUrl;
        link.setAttribute('download', `antares-locus-${this.locus.id}.pdf`);
        document.body.appendChild(link);
        link.click();
      } finally {
        this.loadingFinderChart = false;
      }
    },
  },
});
</script>

<style scoped>
.locus-property-list {
  margin-bottom: 0;
}
</style>
